
import java.io.IOException;
import java.lang.NumberFormatException;

/**
 * Klasse mit Hilfsfunktionen fuer Informatik I.
 * @author Jens Hahn
 */

public class Infotools
{
  private static byte inputbuffer[] = new byte[1024];

  /**
   * Liest ein int vom Standard Input.
   */
  public static int readInteger()
  {
    int i;
    int ret=0;

    try
    {
      System.in.read(inputbuffer);

      String s1 = new String(inputbuffer);
      for (i=0 ; i<inputbuffer.length && inputbuffer[i]!=10 ; i++);
      String s2 = s1.substring(0,i);

      try
      {
        Integer integer = Integer.valueOf(s2);
        ret = integer.intValue();
      }
      catch (NumberFormatException e)
      {
        try
        {
          Double d = Double.valueOf(s2);
          ret = d.intValue();
        }
        catch (NumberFormatException e1) {
		}
      }
    }
    catch (IOException e)
    {
      System.out.println("I/O Error");
    }

    return ret;
  }

 /**
   * Liest ein long vom Standard Input.
   */
  public static long readLong()
  {
    int i;
    long ret=0;

    try
    {
      System.in.read(inputbuffer);

      String s1 = new String(inputbuffer);
      for (i=0 ; i<inputbuffer.length && inputbuffer[i]!=10 ; i++);
      String s2 = s1.substring(0,i);

      try
      {
        Long l = Long.valueOf(s2);
        ret = l.longValue();
      }
      catch (NumberFormatException e)
      {
        try
        {
          Double d = Double.valueOf(s2);
          ret = d.longValue();
        }
        catch (NumberFormatException e1) {
		}
      }
    }
    catch (IOException e)
    {
      System.out.println("I/O Error");
    }

    return ret;
  }


  /**
   * Liest ein double vom Standard Input.
   */
  public static double readDouble()
  {
    int i;
    double ret=0;

    try
    {
      System.in.read(inputbuffer);

      String s1 = new String(inputbuffer);
      for (i=0 ; i<inputbuffer.length && inputbuffer[i]!=10 ; i++);
      String s2 = s1.substring(0,i);

      try
      {
        Double d = Double.valueOf(s2);
        ret = d.doubleValue();
      }
      catch (NumberFormatException e1) {
      }
    }
    catch (IOException e)
    {
      System.out.println("I/O Error");
    }

    return ret;
  }

 /**
   * Liest ein float vom Standard Input.
   */
  public static float readFloat()
  {
    int i;
    float ret=0;

    try
    {
      System.in.read(inputbuffer);

      String s1 = new String(inputbuffer);
      for (i=0 ; i<inputbuffer.length && inputbuffer[i]!=10 ; i++);
      String s2 = s1.substring(0,i);

      try
      {
        Float d = Float.valueOf(s2);
        ret = d.floatValue();
      }
      catch (NumberFormatException e1) {
      }
    }
    catch (IOException e)
    {
      System.out.println("I/O Error");
    }

    return ret;
  }

  /**
   * Liest ein char vom Standard Input.
   */
  public static char readChar()
  {
    char ret=0;

    try {
      System.in.read(inputbuffer);
      ret = (char) inputbuffer[0];
    }
    catch (IOException e) {
      System.out.println("I/O Error");
    }

    return ret;
  }



	public static String readString(){
		String ret="default";

    	try {
      		System.in.read(inputbuffer);
      		ret = new String(inputbuffer);//.toString();
    	}
    	catch (IOException e) {
      		System.out.println("I/O Error"+e.toString());
   		 }

    return ret;
  }
}






